package si.mojeznanje;

import org.apache.log4j.Logger;
import org.glassfish.grizzly.http.server.HttpServer;
import org.glassfish.jersey.grizzly2.httpserver.GrizzlyHttpServerFactory;
import org.glassfish.jersey.jackson.JacksonFeature;
import org.glassfish.jersey.server.ResourceConfig;
import si.mojeznanje.model.Lokacija;
import si.mojeznanje.model.OgradaSet;
import si.mojeznanje.service.ZapisovalecHibernate;
import si.mojeznanje.service.datoteka.ZapisovalecXML;
import si.mojeznanje.service.ip.IpApiJersey;
import si.mojeznanje.service.rest.OgradaService;
import si.mojeznanje.service.rest.TestService;
import si.mojeznanje.service.rest.ZivaliService;
import si.mojeznanje.util.HibernateUtil;
import si.mojeznanje.view.VnosPodatkov;

import javax.ws.rs.core.UriBuilder;
import javax.xml.bind.JAXB;
import javax.xml.bind.JAXBContext;
import java.net.URI;

//https://we.tl/hGnh4KTWCX
// baza : https://we.tl/WTuDSzUM61
public class Main {

    private static HttpServer httpServer = null;

    public static void main(String[] args) {


        Logger logger = Logger.getLogger(Main.class);

        logger.info("Program se zacenja");


        httpServer = startServer();

        Runtime.getRuntime().addShutdownHook(new Thread(
                new Runnable() {
                    @Override
                    public void run() {
                        httpServer.shutdown();
                        HibernateUtil.shutdown();
                        System.exit(0);
                    }
                }
        ));


    }

    private static void pretvoriVXmlTest() {


        ZapisovalecHibernate zapisovalec = new ZapisovalecHibernate();

        OgradaSet ograda = zapisovalec.preberi(OgradaSet.class, 2);

        ZapisovalecXML<OgradaSet> xml = new ZapisovalecXML<OgradaSet>(OgradaSet.class, "ograda.xml");

        xml.shrani(ograda);
    }

    private static void preberiIzXml(){

        OgradaSet ograda = null;

        ZapisovalecXML<OgradaSet> xml = new ZapisovalecXML<OgradaSet>(OgradaSet.class, "ograda.xml");

        ograda = xml.preberi();

    }

    private static URI getBaseURI(){
        return UriBuilder.fromUri("http://0.0.0.0/").port(8080).build();
    }

    public static HttpServer startServer(){

        HttpServer httpServer = null;
        ResourceConfig resourceConfig = new ResourceConfig();
        resourceConfig.registerClasses(TestService.class,
                ZivaliService.class,
                OgradaService.class);

        resourceConfig.register(JacksonFeature.class);
        resourceConfig.register(JAXBContext.class);
        resourceConfig.register(JAXB.class);

        try {
            httpServer = GrizzlyHttpServerFactory.createHttpServer(getBaseURI(), resourceConfig,true);
        }
        catch (Exception e){
            System.out.println("Napaka pri kreaciji strznika");
        }

        return httpServer;
    }

    public static void rocniVnos(){

        OgradaSet ograda = null;
        VnosPodatkov vnosPodatkov = new VnosPodatkov();

        ZapisovalecHibernate hibernate = new ZapisovalecHibernate();

        ograda = hibernate.preberi(OgradaSet.class, 2);

        ograda.dodajZivali(vnosPodatkov.dodajVecZivali());
        ograda.izipisiVseZivali();

        if(ograda.getLokacija() == null){

            Lokacija lokacija = IpApiJersey.mojaLokacija();
            lokacija.setOgradaId(ograda.getId());
            ograda.setLokacija(lokacija);
        }


        hibernate.shrani(ograda);
    }
}
